Subject: RE: A question about RFC2960.

From: [email-masked]
Date: Fri, 5 Sep 2003 15:17:37 +0300

Hi all!

> > >Because in rule E1 you set cwnd <- MTU.  Becaue of this, 
> for a single homed
> > >association, it will take a SACK to increase cwnd and any 
> messages that would
> > >not fit in the retransmitted packet will normally have to 
> wait for a SACK.
> > 
> > Re:
> >    I see. But sctp will send a second packet when we do the 
> implementation. Because:
> > 			flight_size < CWND
> >    So sctp can send more than one packets for a single 
> homed association in fact.
> 
> See implementation guide section 2.7.

	Actually in think that section 2.7 states what Wei is saying.

	An idle address will have its cwnd set to 2*MTU, so you could send couple of packets. However, you are limited to one only...

	In fact there is another problem. When you send a DATA chunk you only count as being on flight (MTU - IP Header Length - SCTP Header Length - DATA Chunk Header Length). So even if your cwnd is set to 1*MTU you can in theory have always at least two full packets in flight, thanks to what 2.7 in the Implementer's Guide says.

	I think we have already spoken about this issue, and the general thought was that, as you don't really know how "separate" are your "different" paths (they might have much in common as they come from and go to the same physical destinations), you better send a single packet, since both paths might be sharing the congested router...

	But I'm with Wei here: as you won't normally send much packets to the secondary address (only those that were in flight when T3 expired), removing this rule of a single packet only after T3 expiration, can in fact halve the recovery time after a T3 expiration... I don't know which can be the damage, though... :-/

	BR Iván Arias Rodríguez

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Fri, 5 Sep 2003 07:29:51 -0600

Ivan.Arias-Rodriguez,

On Fri, 05 Sep 2003, [email-masked] wrote:

> 	An idle address will have its cwnd set to 2*MTU, so you could send
> 	couple of packets. However, you are limited to one only...

Where does it say that? E1, E2 and E3 allow you to send as soon as cwnd
permits (which is immediately in the multiple homed case).

> 
> 	In fact there is another problem. When you send a DATA chunk you only
> 	count as being on flight (MTU - IP Header Length - SCTP Header Length
> 	- DATA Chunk Header Length). So even if your cwnd is set to 1*MTU you
> 	can in theory have always at least two full packets in flight, thanks
> 	to what 2.7 in the Implementer's Guide says.
> 
> 	I think we have already spoken about this issue, and the general
> 	thought was that, as you don't really know how "separate" are your
> 	"different" paths (they might have much in common as they come from
> 	and go to the same physical destinations), you better send a single
> 	packet, since both paths might be sharing the congested router...
> 
> 	But I'm with Wei here: as you won't normally send much packets to the
> 	secondary address (only those that were in flight when T3 expired),
> 	removing this rule of a single packet only after T3 expiration, can in
> 	fact halve the recovery time after a T3 expiration... I don't know
> 	which can be the damage, though... :-/

What single packet rule?  There is no single packet rule in the RFC.

That was my point in highlighting 2.7.

--brian

-- 
Brian F. G. Bidulock    ¦ The reasonable man adapts himself to the ¦
[email-masked]    ¦ world; the unreasonable one persists in  ¦
http://www.openss7.org/ ¦ trying  to adapt the  world  to himself. ¦
                        ¦ Therefore  all  progress  depends on the ¦
                        ¦ unreasonable man. -- George Bernard Shaw ¦